import { Component, h, Prop, Host } from '@stencil/core';
import { Variants } from '../../shared/bootstrap.dto';
export class BxBadge {
    constructor() {
        this.variant = Variants.primary;
        this.pill = false;
    }
    render() {
        let badgeClass = `badge ${this.pill ? 'badge-pill' : ''} badge-${this.variant}`;
        let content = this.text ? this.text : h("slot", null);
        return (this.link
            ? h("a", { href: this.link, class: badgeClass, target: this.target }, content)
            : h(Host, { class: badgeClass }, content));
    }
    static get is() { return "bx-badge"; }
    static get originalStyleUrls() { return {
        "$": ["bx-badge.css"]
    }; }
    static get styleUrls() { return {
        "$": ["bx-badge.css"]
    }; }
    static get properties() { return {
        "variant": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "Variants",
                "resolved": "Variants.danger | Variants.dark | Variants.info | Variants.light | Variants.primary | Variants.secondary | Variants.success | Variants.warning",
                "references": {
                    "Variants": {
                        "location": "import",
                        "path": "../../shared/bootstrap.dto"
                    }
                }
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "variant",
            "reflect": false,
            "defaultValue": "Variants.primary"
        },
        "text": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": true,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "text",
            "reflect": false
        },
        "pill": {
            "type": "boolean",
            "mutable": false,
            "complexType": {
                "original": "boolean",
                "resolved": "boolean",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "pill",
            "reflect": false,
            "defaultValue": "false"
        },
        "link": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": true,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "link",
            "reflect": false
        },
        "target": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": true,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "target",
            "reflect": false
        }
    }; }
}
