import { Component, Host, h, Prop, Method, Element } from '@stencil/core';
import { Variants } from '../../shared/bootstrap.dto';
export class BxSpinner {
    constructor() {
        this.variant = Variants.primary;
        this.small = false;
        this.grow = false;
    }
    render() {
        let spinnerType = `spinner-${this.grow ? 'grow' : 'border'}`;
        let spinnerSize = this.small ? `${spinnerType}-sm` : null;
        let spinnerClass = `${spinnerType} text-${this.variant} ${spinnerSize}`;
        return (h(Host, { class: spinnerClass, role: "status" },
            h("span", { class: "sr-only" }, "Loading...")));
    }
    async dispose() {
        this.element.remove();
    }
    static get is() { return "bx-spinner"; }
    static get originalStyleUrls() { return {
        "$": ["bx-spinner.css"]
    }; }
    static get styleUrls() { return {
        "$": ["bx-spinner.css"]
    }; }
    static get properties() { return {
        "variant": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "Variants",
                "resolved": "Variants.danger | Variants.dark | Variants.info | Variants.light | Variants.primary | Variants.secondary | Variants.success | Variants.warning",
                "references": {
                    "Variants": {
                        "location": "import",
                        "path": "../../shared/bootstrap.dto"
                    }
                }
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "variant",
            "reflect": false,
            "defaultValue": "Variants.primary"
        },
        "small": {
            "type": "boolean",
            "mutable": false,
            "complexType": {
                "original": "boolean",
                "resolved": "boolean",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "small",
            "reflect": false,
            "defaultValue": "false"
        },
        "grow": {
            "type": "boolean",
            "mutable": false,
            "complexType": {
                "original": "boolean",
                "resolved": "boolean",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "grow",
            "reflect": false,
            "defaultValue": "false"
        }
    }; }
    static get methods() { return {
        "dispose": {
            "complexType": {
                "signature": "() => Promise<void>",
                "parameters": [],
                "references": {
                    "Promise": {
                        "location": "global"
                    }
                },
                "return": "Promise<void>"
            },
            "docs": {
                "text": "",
                "tags": []
            }
        }
    }; }
    static get elementRef() { return "element"; }
}
