var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { r as registerInstance, c as createEvent, h, H as Host, g as getElement } from './index-fb59ea2a.js';
var Variants;
(function (Variants) {
    Variants["primary"] = "primary";
    Variants["secondary"] = "secondary";
    Variants["success"] = "success";
    Variants["danger"] = "danger";
    Variants["warning"] = "warning";
    Variants["info"] = "info";
    Variants["light"] = "light";
    Variants["dark"] = "dark";
})(Variants || (Variants = {}));
var AdditionalVariants;
(function (AdditionalVariants) {
    AdditionalVariants["link"] = "link";
})(AdditionalVariants || (AdditionalVariants = {}));
var Sizes;
(function (Sizes) {
    Sizes["large"] = "lg";
    Sizes["small"] = "sm";
})(Sizes || (Sizes = {}));
var bxAlertCss = "bx-alert{display:block}";
var BxAlert = /** @class */ (function () {
    function class_1(hostRef) {
        registerInstance(this, hostRef);
        this.variant = Variants.primary;
        this.dismissible = false;
        this.closing = createEvent(this, "closing", 7);
        this.closed = createEvent(this, "closed", 7);
    }
    class_1.prototype.dismissibleContent = function () {
        return (h("button", { type: "button", class: "close", "aria-label": "Close", onClick: this.close.bind(this) }, h("span", { "aria-hidden": "true" }, "\u00D7")));
    };
    class_1.prototype.render = function () {
        var alertClass = "alert alert-" + this.variant;
        alertClass = this.dismissible ? alertClass + " alert-dismissible show fade" : alertClass; // append dismissible classess
        return (h(Host, { class: alertClass, role: "alert" }, this.text ? this.text : h("slot", null), this.dismissible ? this.dismissibleContent() : null));
    };
    // methods
    class_1.prototype.alert = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.dismissible = true];
            });
        });
    };
    class_1.prototype.close = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                this.closing.emit();
                this.element.classList.remove('show');
                window.setTimeout(function () {
                    _this.closed.emit();
                    _this.element.remove();
                }, 200);
                return [2 /*return*/];
            });
        });
    };
    class_1.prototype.dispose = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.element.remove();
                return [2 /*return*/];
            });
        });
    };
    Object.defineProperty(class_1.prototype, "element", {
        get: function () { return getElement(this); },
        enumerable: true,
        configurable: true
    });
    return class_1;
}());
BxAlert.style = bxAlertCss;
var bxBadgeCss = ":host{display:block}";
var BxBadge = /** @class */ (function () {
    function BxBadge(hostRef) {
        registerInstance(this, hostRef);
        this.variant = Variants.primary;
        this.pill = false;
    }
    BxBadge.prototype.render = function () {
        var badgeClass = "badge " + (this.pill ? 'badge-pill' : '') + " badge-" + this.variant;
        var content = this.text ? this.text : h("slot", null);
        return (this.link
            ? h("a", { href: this.link, class: badgeClass, target: this.target }, content)
            : h(Host, { class: badgeClass }, content));
    };
    return BxBadge;
}());
BxBadge.style = bxBadgeCss;
var bxBreadcrumbCss = "bx-breadcrumb .breadcrumb-item--custom+.breadcrumb-item--custom::before{content:attr(data-separator)}";
var BxBreadcrumb = /** @class */ (function () {
    function class_2(hostRef) {
        registerInstance(this, hostRef);
        this.separator = '/';
        this.clicked = createEvent(this, "clicked", 7);
    }
    class_2.prototype.componentWillLoad = function () {
        this.breadcrumbs = this.parseBreadcrumbs;
    };
    Object.defineProperty(class_2.prototype, "parseBreadcrumbs", {
        get: function () {
            return (typeof this.breadcrumbs === 'string')
                ? JSON.parse(this.breadcrumbs)
                : this.breadcrumbs;
        },
        enumerable: true,
        configurable: true
    });
    class_2.prototype.computedBreadcrumbs = function () {
        try {
            var breadcrumbs_1 = this.parseBreadcrumbs;
            var hasActive_1 = Boolean(breadcrumbs_1.find(function (breadcrumb) { return breadcrumb.active; }));
            var computedbreadcrumbs = breadcrumbs_1.map(function (breadcrumb, index) {
                breadcrumb.link = breadcrumb.link || "#" + breadcrumb.text; // if not link add hashtag for label
                breadcrumb.active = hasActive_1 ? breadcrumb.active : (breadcrumbs_1.length === index + 1); // if not active last level is active
                return breadcrumb;
            });
            return computedbreadcrumbs;
        }
        catch (e) {
            console.error('Invalid format passed for breadcrumbs', e.stack);
        }
    };
    class_2.prototype.generateBreadcrumb = function (breadcrumb) {
        var className = 'breadcrumb-item breadcrumb-item--custom';
        className = breadcrumb.active ? className + " active" : className;
        return (h("li", { class: className, "aria-current": breadcrumb.active ? 'page' : null, "data-separator": this.separator }, breadcrumb.active
            ? h("span", null, breadcrumb.text)
            : h("a", { href: breadcrumb.link, onClick: this.onClick.bind(this, breadcrumb) }, breadcrumb.text)));
    };
    class_2.prototype.onClick = function (breadcrumb) {
        this.makeActive(breadcrumb);
        this.clicked.emit(breadcrumb);
    };
    class_2.prototype.makeActive = function (selected) {
        var updatedBreadcrumbs = this.computedBreadcrumbs().map(function (breadcrumb) {
            breadcrumb.active = (breadcrumb.text === selected.text);
            return breadcrumb;
        });
        this.breadcrumbs = updatedBreadcrumbs;
    };
    class_2.prototype.render = function () {
        var _this = this;
        return (h("ol", { class: "breadcrumb" }, this.breadcrumbs
            ? this.computedBreadcrumbs().map(function (breadcrumb) {
                return _this.generateBreadcrumb(breadcrumb);
            })
            : h("slot", null)));
    };
    class_2.prototype.add = function (breadcrumb) {
        return __awaiter(this, void 0, void 0, function () {
            var breadCrumbs;
            return __generator(this, function (_a) {
                breadCrumbs = this.computedBreadcrumbs();
                breadCrumbs.push(breadcrumb);
                this.breadcrumbs = breadCrumbs;
                return [2 /*return*/];
            });
        });
    };
    class_2.prototype.active = function (text) {
        return __awaiter(this, void 0, void 0, function () {
            var breadcrumbs;
            return __generator(this, function (_a) {
                breadcrumbs = this.computedBreadcrumbs().find(function (breadcrumb) { return breadcrumb.text === text; });
                this.makeActive(breadcrumbs);
                return [2 /*return*/];
            });
        });
    };
    class_2.prototype.delete = function (text) {
        return __awaiter(this, void 0, void 0, function () {
            var breadcrumbs;
            return __generator(this, function (_a) {
                breadcrumbs = this.computedBreadcrumbs().filter(function (breadcrumb) { return breadcrumb.text !== text; });
                this.breadcrumbs = breadcrumbs;
                return [2 /*return*/];
            });
        });
    };
    class_2.prototype.dispose = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.element.remove();
                return [2 /*return*/];
            });
        });
    };
    Object.defineProperty(class_2.prototype, "element", {
        get: function () { return getElement(this); },
        enumerable: true,
        configurable: true
    });
    return class_2;
}());
BxBreadcrumb.style = bxBreadcrumbCss;
var bxButtonCss = ":host{display:block}";
var BxButton = /** @class */ (function () {
    function class_3(hostRef) {
        registerInstance(this, hostRef);
        this.variant = Variants.primary;
        this.outline = false;
        this.block = false;
        this.active = false;
        this.disabled = false;
    }
    class_3.prototype.render = function () {
        var buttonClass = "btn btn-" + (this.outline ? 'outline-' : '') + this.variant;
        buttonClass = this.size ? buttonClass + " btn-" + Sizes[this.size] : buttonClass;
        buttonClass = this.block ? buttonClass + " btn-block" : buttonClass;
        buttonClass = this.active ? buttonClass + " active" : buttonClass;
        buttonClass = this.disabled ? buttonClass + " disabled" : buttonClass;
        var content = this.text ? this.text : h("slot", null);
        return (this.link
            ? h("a", { href: this.link, target: this.target, class: buttonClass, role: "button", tabindex: this.disabled ? '-1' : undefined, "aria-disabled": this.disabled ? 'true' : undefined }, content)
            : h(Host, { class: buttonClass, role: "button", disabled: this.disabled, "aria-disabled": this.disabled ? 'true' : undefined }, content));
    };
    class_3.prototype.toggle = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.active = true;
                return [2 /*return*/];
            });
        });
    };
    class_3.prototype.dispose = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.element.remove();
                return [2 /*return*/];
            });
        });
    };
    Object.defineProperty(class_3.prototype, "element", {
        get: function () { return getElement(this); },
        enumerable: true,
        configurable: true
    });
    return class_3;
}());
BxButton.style = bxButtonCss;
var bxSpinnerCss = ":host{display:block}";
var BxSpinner = /** @class */ (function () {
    function class_4(hostRef) {
        registerInstance(this, hostRef);
        this.variant = Variants.primary;
        this.small = false;
        this.grow = false;
    }
    class_4.prototype.render = function () {
        var spinnerType = "spinner-" + (this.grow ? 'grow' : 'border');
        var spinnerSize = this.small ? spinnerType + "-sm" : null;
        var spinnerClass = spinnerType + " text-" + this.variant + " " + spinnerSize;
        return (h(Host, { class: spinnerClass, role: "status" }, h("span", { class: "sr-only" }, "Loading...")));
    };
    class_4.prototype.dispose = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.element.remove();
                return [2 /*return*/];
            });
        });
    };
    Object.defineProperty(class_4.prototype, "element", {
        get: function () { return getElement(this); },
        enumerable: true,
        configurable: true
    });
    return class_4;
}());
BxSpinner.style = bxSpinnerCss;
export { BxAlert as bx_alert, BxBadge as bx_badge, BxBreadcrumb as bx_breadcrumb, BxButton as bx_button, BxSpinner as bx_spinner };
